package cn.com.qmth.examcloud.core.examwork.api.controller.bean;

import java.util.Date;
import java.util.Map;

import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.validation.constraints.NotNull;

import cn.com.qmth.examcloud.commons.web.cloud.api.JsonSerializable;
import cn.com.qmth.examcloud.core.examwork.dao.enums.ExamType;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年8月17日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class ExamDomain implements JsonSerializable {

	private static final long serialVersionUID = 4009839764353162256L;

	private Long id;

	/**
	 * 顶级机构Id
	 */
	private Long rootOrgId;

	/**
	 * 考试批次开始时间
	 */
	private Date beginTime;

	/**
	 * 考试批次结束时间
	 */
	private Date endTime;

	/**
	 * 考试名称
	 */
	@NotNull
	private String name;

	/**
	 * 考试类型
	 */
	@Enumerated(EnumType.STRING)
	private ExamType examType;

	/**
	 * 考试时长
	 */
	private Integer duration;

	/**
	 * 是否可用
	 */
	private Boolean enable;

	/**
	 * 考试备注
	 */
	private String remark;

	/**
	 * 考试次数
	 */
	private Long examTimes;

	/**
	 * 更新时间
	 */
	private Date updateTime;

	/**
	 * 创建时间
	 */
	private Date creationTime;

	/**
	 * 是否开考
	 */
	private Boolean started;

	/**
	 * 是否禁止考试
	 */
	private Boolean examLimit;

	private Map<String, String> properties;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Date getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(Date beginTime) {
		this.beginTime = beginTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public ExamType getExamType() {
		return examType;
	}

	public void setExamType(ExamType examType) {
		this.examType = examType;
	}

	public Integer getDuration() {
		return duration;
	}

	public void setDuration(Integer duration) {
		this.duration = duration;
	}

	public Boolean getEnable() {
		return enable;
	}

	public void setEnable(Boolean enable) {
		this.enable = enable;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Long getExamTimes() {
		return examTimes;
	}

	public void setExamTimes(Long examTimes) {
		this.examTimes = examTimes;
	}

	public Map<String, String> getProperties() {
		return properties;
	}

	public void setProperties(Map<String, String> properties) {
		this.properties = properties;
	}

	public Boolean getStarted() {
		return started;
	}

	public void setStarted(Boolean started) {
		this.started = started;
	}

	public Date getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}

	public Date getCreationTime() {
		return creationTime;
	}

	public void setCreationTime(Date creationTime) {
		this.creationTime = creationTime;
	}

	public Boolean getExamLimit() {
		return examLimit;
	}

	public void setExamLimit(Boolean examLimit) {
		this.examLimit = examLimit;
	}

}
