package cn.com.qmth.examcloud.core.examwork.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;
import org.springframework.transaction.annotation.Transactional;

import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamOrgSettingsEntity;

public interface ExamOrgSettingsRepo
		extends
			JpaRepository<ExamOrgSettingsEntity, Long>,
			QueryByExampleExecutor<ExamOrgSettingsEntity>,
			JpaSpecificationExecutor<ExamOrgSettingsEntity> {

	@Transactional
	@Modifying
	@Query("delete from ExamOrgSettingsEntity where examId = ?1")
	void deleteByExamId(Long examId);

	@Transactional
	@Modifying
	@Query("delete from ExamOrgSettingsEntity where examId = ?1 and orgId = ?2")
	void deleteByExamIdAndOrgId(Long examId, Long orgId);

	ExamOrgSettingsEntity findByExamIdAndOrgId(Long examId, Long orgId);

	List<ExamOrgSettingsEntity> findAllByExamId(Long examId);

}
